Package com.emc.documentum.rest.dfc

# Interface VersioningManager

public interface VersioningManager
The versioning manager.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `SysObject`
  `cancelCheckOut(String id)`
  Deprecated.
  since feldspar 16.3, please use method cancelCheckOut(String id,LockOptions lockOptions)
  `SysObject`
  `cancelCheckOut(String id, com.emc.documentum.rest.dfc.util.LockOptions lockOptions)`
  Cancel check out specified object by its id
  `<T extends SysObject>
  T`
  `cancelCheckOut(String id, Class<T> targetClass)`
  Cancel check out specified object by its id
  `SysObject`
  `checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment)`
  Deprecated.
  Since 7.3, please use the generic method `checkIn(String, ContentfulObject, String, CheckinPolicy, boolean, int, String, boolean, String)`.
  `<T extends SysObject>
  T`
  `checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment, Class<T> targetClass)`
  Check in specified object
  `SysObject`
  `checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, long contentLength, String charset, boolean retainLock, String comment)`
  Check in specified object
  `<T extends SysObject>
  T`
  `checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, boolean retainLock, String comment)`
  Check in specified object
  `<T extends ContentfulObject>
  T`
  `checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, String format, boolean retainLock, String comment)`
  Check in specified object
  `<T extends ContentfulObject>
  T`
  `checkInWithContents(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment)`
  check in the object contents, the object metadata is optional.
  `<T extends ContentfulObject>
  T`
  `checkInWithRenditions(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment)`
  check in the object contents, the object metadata is optional.
  `SysObject`
  `checkOut(String id)`
  Deprecated.
  since feldspar 16.3, please use method checkOut(String id,LockOptions lockOptions)
  `SysObject`
  `checkOut(String id, com.emc.documentum.rest.dfc.util.LockOptions lockOptions)`
  Check out specified object by its id
  `<T extends SysObject>
  T`
  `checkOut(String id, Class<T> targetClass)`
  Check out specified object by its id
  `SysObject`
  `getCurrentVersion(String id)`
  Get current object by an object id.
  `<T extends SysObject>
  T`
  `getCurrentVersion(String id, Class<T> targetClass)`
  Get current object by an object id.

- ## Method Details

  - ### checkOut

    @Deprecated SysObject checkOut(String id) throws com.documentum.fc.common.DfException
    Deprecated.
    since feldspar 16.3, please use method checkOut(String id,LockOptions lockOptions)
    Check out specified object by its id
    Parameters:
      `id` - The ID of sysobject to be checked out
    Returns:
      checked out object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkOut

    SysObject checkOut(String id, com.emc.documentum.rest.dfc.util.LockOptions lockOptions) throws com.documentum.fc.common.DfException
    Check out specified object by its id
    Parameters:
      `id` - The ID of the object to be checked out
      `lockOptions` - Specify the checkout behavior for a virtual document
    Returns:
      checked out object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkOut

    <T extends SysObject> T checkOut(String id, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Check out specified object by its id
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `id` - The ID of sysobject to be checked out
      `targetClass` - the return class instance type for the model
    Returns:
      checked out object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### cancelCheckOut

    @Deprecated SysObject cancelCheckOut(String id) throws com.documentum.fc.common.DfException
    Deprecated.
    since feldspar 16.3, please use method cancelCheckOut(String id,LockOptions lockOptions)
    Cancel check out specified object by its id
    Parameters:
      `id` - The ID of sysobject to be cancelled
    Returns:
      cancelled object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### cancelCheckOut

    <T extends SysObject> T cancelCheckOut(String id, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Cancel check out specified object by its id
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `id` - The ID of sysobject to be cancelled
      `targetClass` - the return class instance type for the model
    Returns:
      cancelled object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### cancelCheckOut

    SysObject cancelCheckOut(String id, com.emc.documentum.rest.dfc.util.LockOptions lockOptions) throws com.documentum.fc.common.DfException
    Cancel check out specified object by its id
    Parameters:
      `id` - The ID of sysobject to be cancelled
      `lockOptions` - Specify the cancel checkout behavior for a virtual document
    Returns:
      cancelled object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    <T extends ContentfulObject> T checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, String format, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Check in specified object
    Type Parameters:
      `T` - the ContentfulObject or its subclass
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in, it may contains attributes need be updated
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    <T extends SysObject> T checkIn(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Check in specified object
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in, it may contains attributes need be updated
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    @Deprecated SysObject checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Deprecated.
    Since 7.3, please use the generic method `checkIn(String, ContentfulObject, String, CheckinPolicy, boolean, int, String, boolean, String)`.
    Check in specified object
    Parameters:
      `chronicleId` - the root id of the version tree
      `id` - the object id to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `contentStream` - the content stream
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    SysObject checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, long contentLength, String charset, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    Check in specified object
    Parameters:
      `chronicleId` - the root id of the version tree
      `id` - the object id to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `contentStream` - the content stream
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `contentLength` - the length of the content
      `charset` - the charset of the content
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkIn

    <T extends SysObject> T checkIn(String chronicleId, String id, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, InputStream contentStream, int pageNumber, String format, boolean retainLock, String comment, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Check in specified object
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `chronicleId` - the root id of the version tree
      `id` - the object id to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `contentStream` - the content stream
      `pageNumber` - the rendition page number
      `format` - the rendition format
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
      `targetClass` - the return class instance type for the model
    Returns:
      checked in object
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### checkInWithContents

    <T extends ContentfulObject> T checkInWithContents(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    check in the object contents, the object metadata is optional. the object has more than one content to be checked in all the content will be saved as the primary content, starts from the page of pageNumber
    Type Parameters:
      `T` - the type of ContentfulObject
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `pageNumber` - the rendition page number
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      the checked in object
    Throws:
      `com.documentum.fc.common.DfException` - any exceptions

  - ### checkInWithRenditions

    <T extends ContentfulObject> T checkInWithRenditions(String chronicleId, T object, String versionLabels, CheckinPolicy versionPolicy, boolean makeCurrent, int pageNumber, boolean retainLock, String comment) throws com.documentum.fc.common.DfException
    check in the object contents, the object metadata is optional. the object has more than one content to be checked in the first content in the content collection will be saved as the primary content, and all remaining will be saved as renditions on the specified page.
    Type Parameters:
      `T` - the type of ContentfulObject
    Parameters:
      `chronicleId` - the root id of the version tree
      `object` - the object to be checked in
      `versionLabels` - comma delimited symbolic labels to set for the new version; 'CURRENT' and numeric labels are not allowed; if makeCurrent is set to False, at least one symbolic label(s) must be specified.
      `versionPolicy` - CheckinPolicy
      `makeCurrent` - set to True if making the new version as CURRENT version.
      `pageNumber` - the rendition page number
      `retainLock` - whether keep lock after check in
      `comment` - the check in comment
    Returns:
      the checked in object
    Throws:
      `com.documentum.fc.common.DfException` - any exceptions

  - ### getCurrentVersion

    SysObject getCurrentVersion(String id) throws com.documentum.fc.common.DfException
    Get current object by an object id.
    Parameters:
      `id` - the object id
    Returns:
      the current version of the version tree
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation

  - ### getCurrentVersion

    <T extends SysObject> T getCurrentVersion(String id, Class<T> targetClass) throws com.documentum.fc.common.DfException
    Get current object by an object id.
    Type Parameters:
      `T` - the SysObject or its subclass
    Parameters:
      `id` - the object id
      `targetClass` - the return class instance type for the model
    Returns:
      the current version of the version tree
    Throws:
      `com.documentum.fc.common.DfException` - when any exception is caught during the operation